// ImageProcessingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ImageProcessing.h"
#include "ImageProcessingDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CImageProcessingDlg dialog




CImageProcessingDlg::CImageProcessingDlg(CWnd* pParent /*=NULL*/)
: CDialog(CImageProcessingDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CImageProcessingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CImageProcessingDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_IMAGELOAD, &CImageProcessingDlg::OnBnClickedImageload)
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()

	ON_BN_CLICKED(IDC_MESHSET, &CImageProcessingDlg::OnBnClickedMeshset)
	ON_BN_CLICKED(IDC_APPLY, &CImageProcessingDlg::OnBnClickedApply)
	ON_BN_CLICKED(IDC_MESHFORMAT, &CImageProcessingDlg::OnBnClickedMeshformat)
	ON_BN_CLICKED(IDC_SCRMESH1, &CImageProcessingDlg::OnBnClickedSrcmesh1)
	ON_BN_CLICKED(IDC_SCRMESH2, &CImageProcessingDlg::OnBnClickedSrcmesh2)
	ON_BN_CLICKED(IDC_DESTMESH1, &CImageProcessingDlg::OnBnClickedDestmesh1)
	ON_BN_CLICKED(IDC_DESTMESH2, &CImageProcessingDlg::OnBnClickedDestmesh2)
	ON_BN_CLICKED(IDC_MESHSAVE, &CImageProcessingDlg::OnBnClickedMeshsave)
	ON_BN_CLICKED(IDC_MESHLOAD, &CImageProcessingDlg::OnBnClickedMeshload)
	ON_BN_CLICKED(IDC_IMAGESAVE, &CImageProcessingDlg::OnBnClickedImagesave)
	ON_BN_CLICKED(IDC_POWER1, &CImageProcessingDlg::OnBnClickedPower1)
	ON_BN_CLICKED(IDC_POWER2, &CImageProcessingDlg::OnBnClickedPower2)
	ON_BN_CLICKED(IDC_POWER3, &CImageProcessingDlg::OnBnClickedPower3)
	ON_BN_CLICKED(IDC_POWER4, &CImageProcessingDlg::OnBnClickedPower4)
	ON_BN_CLICKED(IDC_VIEWER, &CImageProcessingDlg::OnBnClickedViewer)
	ON_BN_CLICKED(IDC_NAVIGATOR2, &CImageProcessingDlg::OnBnClickedNavigator2)
	ON_BN_CLICKED(IDC_NAVIGATOR3, &CImageProcessingDlg::OnBnClickedNavigator3)
	ON_BN_CLICKED(IDC_NAVIGATOR4, &CImageProcessingDlg::OnBnClickedNavigator4)
	ON_BN_CLICKED(IDC_NAVIGATOR5, &CImageProcessingDlg::OnBnClickedNavigator5)
	ON_BN_CLICKED(IDC_NAVIGATOR1, &CImageProcessingDlg::OnBnClickedNavigator1)
	ON_BN_CLICKED(IDC_CREATEANI, &CImageProcessingDlg::OnBnClickedCreateani)
END_MESSAGE_MAP()


// CImageProcessingDlg message handlers

BOOL CImageProcessingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CImageProcessingDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CImageProcessingDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//////////////////////////////////////////////////////////////////////////////////////
//   ۾.
//////////////////////////////////////////////////////////////////////////////////////
int CImageProcessingDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  Add your specialized creation code here
	m_isMouseMove = false;
	m_isMeshInit = true;
	m_isCreateAni = false;

	m_pMeshWarp = new CMeshWarp;
	m_pMeshWarp->pDlg = this;
	m_AnimationStep = AnimationFrame;
	
	m_SrcMesh = new MESHPOINT[MeshSizeX * MeshSizeY]; 
	m_AnimationMesh = new MESHPOINT**[m_AnimationStep];
	for(int i=0; i<m_AnimationStep; ++i)
		m_AnimationMesh[i] = new MESHPOINT *[m_AnimationStep];

	for(int i=0; i< m_AnimationStep; ++i)
		for(int j=0; j< m_AnimationStep; ++j)
			m_AnimationMesh[i][j] = new MESHPOINT[MeshSizeX * MeshSizeY];

	m_LeftMesh		=		m_AnimationMesh[0][m_AnimationStep>>1];
	m_RightMesh		=		m_AnimationMesh[m_AnimationStep-1][m_AnimationStep>>1];
	m_UpMesh		=		m_AnimationMesh[m_AnimationStep>>1][0];
	m_DownMesh		=		m_AnimationMesh[m_AnimationStep>>1][m_AnimationStep-1];
	m_CenterMesh	=		m_AnimationMesh[m_AnimationStep>>1][m_AnimationStep>>1];

	m_LeftImage = new CImage();
	m_RightImage = new CImage();
	m_UpImage = new CImage();
	m_DownImage = new CImage();
	m_CenterImage = new CImage();
	m_ViewImage = m_CenterImage;

	// ⺻ ޽  ߾
	m_DestMesh = m_CenterMesh;
	
	for(int j=0; j < MeshSizeY; ++j)
	{
		for(int i=0; i < MeshSizeX; ++i)
		{
			MESHPOINT pt = {i*100, j*100, false};
			m_DestMesh[j*MeshSizeY + i] = m_SrcMesh[j*MeshSizeY + i] = pt;
		}
	}

	return 0;
}

void CImageProcessingDlg::OnBnClickedMeshformat()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	((CButton*)GetDlgItem(IDC_SCRMESH1))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_SCRMESH2))->SetCheck(0);
	
	((CButton*)GetDlgItem(IDC_DESTMESH1))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_DESTMESH2))->SetCheck(0);
	
	((CButton*)GetDlgItem(IDC_TRACKING1))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_TRACKING2))->SetCheck(1);

	((CButton*)GetDlgItem(IDC_POWER1))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_POWER2))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_POWER3))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_POWER4))->SetCheck(0);
	m_power = 0;	//  ʱȭ

	((CButton*)GetDlgItem(IDC_DMODIFY1))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_DMODIFY2))->SetCheck(1);
	
	((CButton*)GetDlgItem(IDC_SRCIMAGE1))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_SRCIMAGE2))->SetCheck(1);
	((CButton*)GetDlgItem(IDC_NAVIGATOR3))->SetCheck(1);
	m_DestMesh = m_CenterMesh;

	for(int j=0; j<MeshSizeY; ++j)
	{
		for(int i=0; i<MeshSizeX; ++i)
		{
			int x = (int)((float)i * m_EdgeWidth);
			int y = (int)((float)j * m_EdgeHeight);

			if(i == MeshSizeX-1)
				x = m_ImageWidth-1;
			if(j == MeshSizeY-1)
				y = m_ImageHeight-1;

			MESHPOINT pt = {x, y, false};
			m_DestMesh[j*MeshSizeY + i] = m_SrcMesh[j*MeshSizeY + i] = pt;
		}
	}
	m_isMeshInit = true;
	m_isCreateAni = false;

	this->Invalidate();
}

//////////////////////////////////////////////////////////////////////////////////////
// ȭ ºκ
//////////////////////////////////////////////////////////////////////////////////////
void CImageProcessingDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	if (IsIconic())
	{
		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CString msg;
		//  ϴ 
		if(((CButton*)GetDlgItem(IDC_SRCIMAGE1))->GetCheck())
		{
			if ( !m_SrcImage.IsNull() )
			{
				m_SrcImage.AlphaBlend(dc,0, 0, m_ImageWidth << m_power, m_ImageHeight << m_power,
					0, 0, m_ImageWidth, m_ImageHeight, 128);
			}
			if ( !m_ViewImage->IsNull() )
			{
				m_ViewImage->AlphaBlend(dc,0, 0, m_ImageWidth << m_power, m_ImageHeight << m_power,
					0, 0, m_ImageWidth, m_ImageHeight, 128);
			}
		}
		else if( !m_ViewImage->IsNull() )
		{
			m_ViewImage->Draw(dc,0, 0, m_ImageWidth << m_power, m_ImageHeight << m_power,
					0, 0, m_ImageWidth, m_ImageHeight);
		
		}
//		msg.Format("׸ũ %d x %d  꿡  ڵ  : %d",m_ImageWidth, m_ImageHeight, );
		this->SetDlgItemText(IDC_COMMANDBOX, msg);
		// ޽ ׸..

		//    
		if(((CButton*)GetDlgItem(IDC_SCRMESH1))->GetCheck())
		{
			CBrush brush(RGB(0,255,0));
			dc.SelectObject(&brush);

			for(int j=0; j<MeshSizeY; ++j)
			{
				for(int i=0; i<MeshSizeX; ++i)
				{
					if(i < MeshSizeX-1)
					{
						dc.MoveTo(m_SrcMesh[j*MeshSizeY + i].x  << m_power, m_SrcMesh[j*MeshSizeY + i].y << m_power);
						dc.LineTo(m_SrcMesh[j*MeshSizeY + i+1].x << m_power, m_SrcMesh[j*MeshSizeY + i+1].y << m_power);
					}
					if(j < MeshSizeY-1)
					{
						dc.MoveTo(m_SrcMesh[j*MeshSizeY + i].x << m_power, m_SrcMesh[j*MeshSizeY + i].y << m_power);
						dc.LineTo(m_SrcMesh[(j+1)*MeshSizeY + i].x << m_power, m_SrcMesh[(j+1)*MeshSizeY + i].y << m_power);
					}
					// ܰ ޽ ϰ Ҽ ִ 簢 ׷ش.
					if(i && j && i<MeshSizeX-1 && j<MeshSizeY-1)
						dc.Ellipse((m_SrcMesh[j*MeshSizeY + i].x << m_power)-5, (m_SrcMesh[j*MeshSizeY + i].y << m_power)-5, 
									(m_SrcMesh[j*MeshSizeY + i].x << m_power)+5, (m_SrcMesh[j*MeshSizeY + i].y << m_power)+5);
				}
			}
		}
		//   Ȯ  
		if(((CButton*)GetDlgItem(IDC_DESTMESH1))->GetCheck())
		{
			if(m_isMeshInit == false)
			{
				CBrush brush(RGB(255,0,0));
				dc.SelectObject(&brush);

				for(int j=0; j<MeshSizeY; ++j)
				{
					for(int i=0; i<MeshSizeX; ++i)
					{
						if(i < MeshSizeX-1)
						{
							dc.MoveTo(m_DestMesh[j*MeshSizeY + i].x << m_power, m_DestMesh[j*MeshSizeY + i].y << m_power);
							dc.LineTo(m_DestMesh[j*MeshSizeY + i+1].x << m_power, m_DestMesh[j*MeshSizeY + i+1].y << m_power);
						}
						if(j < MeshSizeY-1)
						{
							dc.MoveTo(m_DestMesh[j*MeshSizeY + i].x << m_power, m_DestMesh[j*MeshSizeY + i].y << m_power);
							dc.LineTo(m_DestMesh[(j+1)*MeshSizeY + i].x << m_power, m_DestMesh[(j+1)*MeshSizeY + i].y << m_power);
						}
						// ܰ ޽ ϰ Ҽ ִ 簢 ׷ش.
						if(i && j && i<MeshSizeX-1 && j<MeshSizeY-1)
							dc.Ellipse((m_DestMesh[j*MeshSizeY + i].x << m_power)-5, (m_DestMesh[j*MeshSizeY + i].y << m_power)-5, 
										(m_DestMesh[j*MeshSizeY + i].x << m_power)+5, (m_DestMesh[j*MeshSizeY + i].y << m_power)+5);
					}
				}
			}
		}

		if(((CButton*)GetDlgItem(IDC_TRACKING1))->GetCheck())
		{
			CString msg;
		//	msg.Format("콺 ġ : %d, %d",
		//		m_NowMousePos.x, m_NowMousePos.y);
	//		dc.TextOut(15,435,msg);
			
			GetFaceCoordnates();
			msg.Format("Ʈŷ ġ : % d, %d", m_TrackingPos.x, m_TrackingPos.y);
			this->SetDlgItemText(IDC_COMMANDBOX, msg);
			
		}

		CDialog::OnPaint();
	}
}

//////////////////////////////////////////////////////////////////////////////////////
//   Լ
//////////////////////////////////////////////////////////////////////////////////////
void CImageProcessingDlg::OnBnClickedImageload()
{
	// TODO: Add your control notification handler code here
	// Get image file name
	CString szFilter = "Image Files(*.BMP, *.GIF, *.JPG, *.PNG) | *.BMP;*.GIF;*.JPG;*.PNG; | All Files(*.*)|*.*||";
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, szFilter);
	if(IDOK != dlg.DoModal()) return;
	CString sFilename = dlg.GetPathName();
	m_ImageName = dlg.GetFileTitle();

	// Detaches the bitmap from the CImage object and destroys the bitmap if image already loaded
	CImage image;
	image.Load(sFilename);

	if ( !m_SrcImage.IsNull() )
	{
		m_SrcImage.Destroy();
	}
	m_SrcImage.Load(sFilename);

	if ( !m_ViewImage->IsNull() )
	{
	//	m_ViewImage->Destroy();
		m_LeftImage->Destroy();
		m_RightImage->Destroy();
		m_UpImage->Destroy();
		m_DownImage->Destroy();
		m_CenterImage->Destroy();
	}
//	m_ViewImage->Create(m_SrcImage.GetWidth(), m_SrcImage.GetHeight(), m_SrcImage.GetBPP());
//	m_ViewImage->Load(sFilename);
	
	m_LeftImage->Create(m_SrcImage.GetWidth(), m_SrcImage.GetHeight(), m_SrcImage.GetBPP());
	m_RightImage->Create(m_SrcImage.GetWidth(), m_SrcImage.GetHeight(), m_SrcImage.GetBPP());
	m_UpImage->Create(m_SrcImage.GetWidth(), m_SrcImage.GetHeight(), m_SrcImage.GetBPP());
	m_DownImage->Create(m_SrcImage.GetWidth(), m_SrcImage.GetHeight(), m_SrcImage.GetBPP());
	m_CenterImage->Create(m_SrcImage.GetWidth(), m_SrcImage.GetHeight(), m_SrcImage.GetBPP());

	m_LeftImage->Load(sFilename);
	m_RightImage->Load(sFilename);
	m_UpImage->Load(sFilename);
	m_DownImage->Load(sFilename);
	m_CenterImage->Load(sFilename);

	// ʱ ߾̹
	m_ViewImage = m_CenterImage;

	m_ImageWidth = m_SrcImage.GetWidth();
	m_ImageHeight =  m_SrcImage.GetHeight();

	m_EdgeWidth = (float)m_ImageWidth / (float)(MeshNumber-1);
	m_EdgeHeight= (float)m_ImageHeight / (float)(MeshNumber-1);

	OnBnClickedMeshformat();	
	
	m_nFilterLoad = dlg.m_ofn.nFilterIndex;
	m_pAniViewer = NULL;
	Invalidate();
}


//  ִ° ׳  ؼ MSDN CImage  ҽ, SimpleImage  SaveԼ copy and phase 
void CImageProcessingDlg::OnBnClickedImagesave()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CString strFilter;
	CSimpleArray<GUID> aguidFileTypes;
	HRESULT hResult;


	strFilter = "Bitmap image|*.bmp|JPEG image|*.jpg|GIF image|*.gif|PNG image|*.png||";

	CFileDialog dlg(FALSE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_EXPLORER,strFilter);
	dlg.m_ofn.nFilterIndex = m_nFilterLoad;
	hResult = (int)dlg.DoModal();
	if (FAILED(hResult)) {
		return;
	}

    // Add the appropriate extension if the user didn't type one

	CString strFileName;
	CString strExtension;

	strFileName = dlg.m_ofn.lpstrFile;


	// add the file extension if the user didn't supply one
	if (dlg.m_ofn.nFileExtension == 0) 
	{
		switch (dlg.m_ofn.nFilterIndex)
		{
		case 1:
			strExtension = "bmp";
			break;
		case 2:
			strExtension = "jpg";
			break;
		case 3:
			strExtension = "gif";
			break;
		case 4:
			strExtension = "png";
			break;
		default:
			break;
		}

		strFileName = strFileName + '.' + strExtension;

	}

	// the extension on the file name will determine the file type that is saved
	hResult = m_ViewImage->Save(strFileName);
	if (FAILED(hResult)) {
		CString fmt;
		fmt.Format("Save image failed:\n%x - %s", hResult, _com_error(hResult).ErrorMessage());
		::AfxMessageBox(fmt);
		return;
	}

}

//  ޽  ޽    ε
void CImageProcessingDlg::OnBnClickedMeshload()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	LPCTSTR szFileFilter = "޽  (*.m) | *.m||";

	CFileDialog dlg(TRUE, "m", "*.m", 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFileFilter);

	if(dlg.DoModal() == IDOK)
	{
		CFile file;
		CFileException e;
		if(!file.Open(dlg.GetFileName(), CFile::modeRead, &e))
		{
			e.ReportError();
			return;
		}

		// ׸ũ⸦ 256x256 Ϸ   short ƴ byte Ÿ .
		short Data[MeshSizeX * MeshSizeX * 2 * 6];
		file.Read(Data, sizeof(short) * MeshSizeX * MeshSizeX * 2 * 6);
		
		int k = 0;
		
		for(int j=0; j<MeshSizeY; ++j)
		{
			for(int i=0; i<MeshSizeX; ++i)
			{
				int l = j*MeshSizeY + i;

				m_SrcMesh[l].x  = Data[k++];
				m_SrcMesh[l].y  = Data[k++];
				m_LeftMesh[l].x = Data[k++];
				m_LeftMesh[l].y = Data[k++];
				m_RightMesh[l].x = Data[k++];
				m_RightMesh[l].y = Data[k++];
				m_UpMesh[l].x = Data[k++];
				m_UpMesh[l].y = Data[k++];
				m_DownMesh[l].x = Data[k++];
				m_DownMesh[l].y = Data[k++];
				m_CenterMesh[l].x = Data[k++];
				m_CenterMesh[l].y = Data[k++];
			}
		}
	}
	m_isMeshInit = false;
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedMeshsave()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CFile file;
	CFileException e;

	LPCTSTR szFileFilter = "޽  (*.m) | *.m||";

	CFileDialog dlg(FALSE, "m", "*.m", 
		OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFileFilter);

	if(dlg.DoModal() == IDOK)
	{
		if(!file.Open(dlg.GetFileName(), CFile::modeWrite | CFile::modeCreate, &e))
		{
			e.ReportError();
			return;
		}

		// ׸ũ⸦ 256x256 Ϸ   short ƴ byte Ÿ .
		short Data[MeshSizeX * MeshSizeX * 2 * 6];
		
		int k = 0;
		
		for(int j=0; j<MeshSizeY; ++j)
		{
			for(int i=0; i<MeshSizeX; ++i)
			{
				int l = j*MeshSizeY + i;

				Data[k++] = m_SrcMesh[l].x;
				Data[k++] = m_SrcMesh[l].y;
				Data[k++] = m_LeftMesh[l].x;
				Data[k++] = m_LeftMesh[l].y;
				Data[k++] = m_RightMesh[l].x;
				Data[k++] = m_RightMesh[l].y;
				Data[k++] = m_UpMesh[l].x;
				Data[k++] = m_UpMesh[l].y;
				Data[k++] = m_DownMesh[l].x;
				Data[k++] = m_DownMesh[l].y;
				Data[k++] = m_CenterMesh[l].x;
				Data[k++] = m_CenterMesh[l].y;
			}
		}
		//    
		file.Write(Data, sizeof(short) * MeshSizeX * MeshSizeY * 2 * 6);

		// Java ְ ϱ... ....
		CString str;
		str.Format("Mesh%s.java",dlg.GetFileTitle());
		CFile warp;
		CFileException e_warp;
		if(!warp.Open(str, CFile::modeWrite | CFile::modeCreate | CFile::typeText, &e_warp))
		{
			e_warp.ReportError();
			return;
		}

		str.Format("public class Mesh%s {\n\tMESHPOINT [][][] animesh;\n\tpublic Mesh%s(){\n",
			dlg.GetFileTitle(),dlg.GetFileTitle());
		warp.Write(str, str.GetLength());
	
		str.Format("\t\tanimesh = new MESHPOINT[%d][%d][%d];\n", AnimationFrame, AnimationFrame, MeshSizeX * MeshSizeY);
		warp.Write(str, str.GetLength());
		
		for(int a=0; a<AnimationFrame; ++a)
			for(int b=0; b<AnimationFrame; ++b)
			{
				//  
				for(int j=0; j<MeshSizeY; ++j)
				{
					for(int i=0; i<MeshSizeX; ++i)
					{
						int l = j*MeshSizeY + i;
						str.Format("\t\tanimesh[%2d][%2d][%2d] = new MESHPOINT(%d, %d);\n",
							a,b, l, m_AnimationMesh[a][b][l].x, m_AnimationMesh[a][b][l].y);
						warp.Write(str, str.GetLength());
					}
				}
			}


		str.Format("\n\t}\n}");
		warp.Write(str, str.GetLength());
	}
}

//  Ų  ϸ̼ ޽ǥ bin ϰ  Ϸ Ѵ
void CImageProcessingDlg::ApplyMeshSave()
{
	CFile mesh_file, c_file, java_file;
	CFileException e;

	// ϴ ̳ʸ ϰ, Clet    Ϸ ̱
	if(!mesh_file.Open(m_ImageName + "_mesh.bin", CFile::modeWrite | CFile::modeCreate, &e))
	{
		e.ReportError();
		return;
	}

	if(!c_file.Open(m_ImageName + "_mesh.h", CFile::modeWrite | CFile::modeCreate, &e))
	{
		e.ReportError();
		return;
	}

	// شκ 
	CString filemsg;
	filemsg.Format("typedef unsigned char byte;\n\nextern byte ani_frame[%d][%d][%d] = {\n",
				AnimationFrame, AnimationFrame, MeshSizeX*MeshSizeY*2);
			
	c_file.Write(filemsg, filemsg.GetLength());

	//   
	MESHPOINT *ptr;
	// ׸ũ⸦ 256x256 Ϸ   short ƴ byte Ÿ .
	for(int k=0; k < AnimationFrame; ++k)
	{
		filemsg.Format("{");
			c_file.Write(filemsg, filemsg.GetLength());
		for(int l=0; l < AnimationFrame; ++l)
		{
			filemsg.Format("{ \n // this mesh is [%d][%d]\n",k,l);
			c_file.Write(filemsg, filemsg.GetLength());

			ptr = m_AnimationMesh[k][l];
			short Data[MeshSizeX * MeshSizeX * 2 * 6];

			int m = 0;
			
			
			for(int j=0; j<MeshSizeY; ++j)
			{
				for(int i=0; i<MeshSizeX; ++i)
				{
					int l = j*MeshSizeY + i;

					Data[m++] = ptr[l].x;
					Data[m++] = ptr[l].y;

					filemsg.Format("%2d, %2d, ",ptr[l].x, ptr[l].y);
					c_file.Write(filemsg, filemsg.GetLength());
				}
				filemsg.Format("\n");
				c_file.Write(filemsg, filemsg.GetLength());
			}

			//    
			mesh_file.Write(Data, sizeof(short) * MeshSizeX * MeshSizeY * 2 * 6);

			filemsg.Format("},");
			c_file.Write(filemsg, filemsg.GetLength());
		}
		filemsg.Format("},\n");
		c_file.Write(filemsg, filemsg.GetLength());
	}
	filemsg.Format("}; \n");
	c_file.Write(filemsg, filemsg.GetLength());

	////////////////////////////////////////////////////////////////////////////////////
	// java Ϸ  
	////////////////////////////////////////////////////////////////////////////////////
	if(!java_file.Open(m_ImageName + "_mesh.java", CFile::modeWrite | CFile::modeCreate, &e))
	{
		e.ReportError();
		return;
	}

	// ش 
	filemsg.Format("public class %s_mesh {\n\n\tbyte [][][] %s_frame = {\n\t\t",m_ImageName,m_ImageName);
	java_file.Write(filemsg, filemsg.GetLength());

	// ׸ũ⸦ 256x256 Ϸ   short ƴ byte Ÿ .
	for(int k=0; k < AnimationFrame; ++k)
	{
		filemsg.Format("{");
		java_file.Write(filemsg, filemsg.GetLength());

		for(int l=0; l < AnimationFrame; ++l)
		{
			filemsg.Format("{ \n\t\t// this mesh is [%d][%d]\n\t\t",k,l);
			java_file.Write(filemsg, filemsg.GetLength());

			ptr = m_AnimationMesh[k][l];
			short Data[MeshSizeX * MeshSizeX * 2 * 6];

			int m = 0;
						
			for(int j=0; j<MeshSizeY; ++j)
			{
				for(int i=0; i<MeshSizeX; ++i)
				{
					int l = j*MeshSizeY + i;

					Data[m++] = ptr[l].x;
					Data[m++] = ptr[l].y;

					filemsg.Format("%2d, %2d, ",ptr[l].x, ptr[l].y);
					java_file.Write(filemsg, filemsg.GetLength());
				}
				filemsg.Format("\n\t\t");
				java_file.Write(filemsg, filemsg.GetLength());
			}

			filemsg.Format("},");
			java_file.Write(filemsg, filemsg.GetLength());
		}
		filemsg.Format("},\n");
		java_file.Write(filemsg, filemsg.GetLength());
	}
	filemsg.Format("}; \n}");
	java_file.Write(filemsg, filemsg.GetLength());


}
//////////////////////////////////////////////////////////////////////////////////////
// 콺 ۾
//////////////////////////////////////////////////////////////////////////////////////
void CImageProcessingDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	//  ܰ ޽ ǵ帮 ʴ´.
	MESHPOINT pt = {point.x << m_power, point.y << m_power, true};

	//  ̹ ʱ  ޽
	if(m_isMeshInit)
	{
		//ƮŰ  ?
		if(GetKeyState(VK_CONTROL) < 0) 
		{
			for(int j=1; j<MeshSizeY-1; ++j)
			{
				for(int i=1; i<MeshSizeX-1; ++i)
				{
				}
			}
		}
		for(int j=1; j<MeshSizeY-1; ++j)
		{
			for(int i=1; i<MeshSizeX-1; ++i)
			{
				if((point.x >= (m_SrcMesh[j*MeshSizeY + i].x << m_power)-5 && point.x <= (m_SrcMesh[j*MeshSizeY + i].x << m_power) + 5) &&
					(point.y >= (m_SrcMesh[j*MeshSizeY + i].y << m_power)-5 && point.y <= (m_SrcMesh[j*MeshSizeY + i].y << m_power) + 5))
				{
					MESHPOINT selectPt = {i,j,true};

					m_SrcMesh[j*MeshSizeY + i].x = pt.x >> m_power;
					m_SrcMesh[j*MeshSizeY + i].y = pt.y >> m_power;
					m_SrcMesh[j*MeshSizeY + i].pick = true;

					m_PickPoint = selectPt;
					m_isMouseMove = true;
					break;
				}
			}
		}
	}
	//   ̹  ޽
	else
	{
		for(int j=1; j<MeshSizeY-1; ++j)
		{
			for(int i=1; i<MeshSizeX-1; ++i)
			{
				if((point.x >= (m_DestMesh[j*MeshSizeY + i].x << m_power)-5 && point.x <= (m_DestMesh[j*MeshSizeY + i].x << m_power) + 5) &&
					(point.y >= (m_DestMesh[j*MeshSizeY + i].y << m_power)-5 && point.y <= (m_DestMesh[j*MeshSizeY + i].y << m_power) + 5))
				{
					MESHPOINT selectPt = {i,j,true};

					m_DestMesh[j*MeshSizeY + i].x = pt.x >> m_power;
					m_DestMesh[j*MeshSizeY + i].y = pt.y >> m_power;
					m_DestMesh[j*MeshSizeY + i].pick = true;
					m_PickPoint = selectPt;
					m_isMouseMove = true;
					break;
				}
			}
		}
	}

	CDialog::OnLButtonDown(nFlags, point);
}

void CImageProcessingDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	MESHPOINT pt = {point.x, point.y, true};
	m_NowMousePos = pt;
	// ޽ ϶ ۾ó
	if(m_isMouseMove)
	{
		point.x -= 5;
		point.y -= 5;

		if(m_isMeshInit)
		{
			m_SrcMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].x = pt.x >> m_power;
			m_SrcMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].y = pt.y >> m_power;
			m_SrcMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].pick = true;
		}
		else
		{
			m_DestMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].x = pt.x >> m_power;
			m_DestMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].y = pt.y >> m_power;
			m_DestMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].pick = true;
		}

		if(!m_isMeshInit && ((CButton*)GetDlgItem(IDC_DMODIFY1))->GetCheck())
			OnBnClickedApply();
		
//		this->Invalidate();
		this->InvalidateRect(CRect(point.x - ((int)(m_EdgeWidth) << m_power),
								point.y - ((int)(m_EdgeHeight) << m_power),
								point.x + ((int)(m_EdgeWidth) << m_power),
								point.y + ((int)(m_EdgeHeight) << m_power)));
	}	

	CDialog::OnMouseMove(nFlags, point);
}


void CImageProcessingDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	MESHPOINT pt = {point.x, point.y, false};

	if(m_isMouseMove)
	{
		m_isMouseMove = false;

		point.x -= 5;
		point.y -= 5;

		if(m_isMeshInit)
		{
			m_SrcMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].x = pt.x >> m_power;
			m_SrcMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].y = pt.y >> m_power;
			m_SrcMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].pick = false;
		}
		else
		{
			m_DestMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].x = pt.x >> m_power;
			m_DestMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].y = pt.y >> m_power;
			m_DestMesh[m_PickPoint.y*MeshSizeY + m_PickPoint.x].pick = false;
		}
		this->Invalidate();
	}

	CDialog::OnLButtonUp(nFlags, point);
}

//////////////////////////////////////////////////////////////////////////////////////
//  ο ʿ ޼ҵ..
//////////////////////////////////////////////////////////////////////////////////////
// α ϴ°. 
void CImageProcessingDlg::OnBnClickedMeshset()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	m_isMeshInit = false;
	for(int j=0; j<MeshSizeY; ++j)
	{
		for(int i=0; i<MeshSizeX; ++i)
		{
			m_LeftMesh[j*MeshSizeY + i] = 
				m_RightMesh[j*MeshSizeY + i] =
				m_UpMesh[j*MeshSizeY + i] =
				m_DownMesh[j*MeshSizeY + i] =
				m_CenterMesh[j*MeshSizeY + i] = m_SrcMesh[j*MeshSizeY + i];
		}
	}
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedApply()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	if(m_isMeshInit)
	{
		MessageBox("޽ ϰ Ұ", "?", MB_OK);
	}
	else
	{
		//	ComputeCount = 0;
		CImage src, dest;
		int w = m_ImageWidth;
		int h = m_ImageHeight;
		// Copy source
		src.Create(w, h, m_SrcImage.GetBPP());
		
		// ̰   CImage ׸ 
		// .BitBlt(CImageDC, ġ)
		// ׸ ݵ CImages ReleaseDC .
		m_SrcImage.BitBlt(src.GetDC(), 0, 0);
		src.ReleaseDC();
		
		// Mesh Warping
		// ̺κ ...  ..
		m_pMeshWarp->MeshWarp(&src, &dest, m_SrcMesh, m_DestMesh, MeshSizeX, MeshSizeY);

		// Median Filtering
//		m_pMeshWarp->MedianFilter(&dest, &src, 3);

		src.BitBlt(m_ViewImage->GetDC(), 0, 0);
		m_ViewImage->ReleaseDC();

		ApplyMeshSave();
		//this->Invalidate();
	}
}

void CImageProcessingDlg::GetFaceCoordnates()
{
	if(m_NowMousePos.x >= 0 && m_NowMousePos.x <= m_ImageWidth &&
		m_NowMousePos.y >= 0 && m_NowMousePos.y <= m_ImageHeight)
	{
		MESHPOINT temp;
		temp.x = m_ImageWidth / 3;
		temp.y = m_ImageHeight / 3;

		m_TrackingPos.x = m_NowMousePos.x / temp.x;
		m_TrackingPos.y = m_NowMousePos.y / temp.y;
	}
}

//////////////////////////////////////////////////////////////////////////////////////
//  ư  ɼ κ
//////////////////////////////////////////////////////////////////////////////////////
// ޽ ׸ on off  簻.
void CImageProcessingDlg::OnBnClickedSrcmesh1()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedSrcmesh2()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedDestmesh1()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedDestmesh2()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->Invalidate();
}

// ￡  ڰ ø.  Ʈ ų .
void CImageProcessingDlg::OnBnClickedPower1()
{
	// TODO: Add your control notification handler code here
	m_power = 0;
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedPower2()
{
	// TODO: Add your control notification handler code here
	m_power = 1;
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedPower3()
{
	// TODO: Add your control notification handler code here
	m_power = 2;
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedPower4()
{
	// TODO: Add your control notification handler code here
	m_power = 3;
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedNavigator1()
{
	// TODO: Add your control notification handler code here
	
	m_DestMesh = m_UpMesh;
	m_ViewImage = m_UpImage;
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedNavigator2()
{
	// TODO: Add your control notification handler code here
	m_DestMesh = m_LeftMesh;
	m_ViewImage = m_LeftImage;
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedNavigator3()
{
	// TODO: Add your control notification handler code here
	m_DestMesh = m_CenterMesh;
	m_ViewImage = m_CenterImage;
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedNavigator4()
{
	// TODO: Add your control notification handler code here
	m_DestMesh = m_RightMesh;
	m_ViewImage = m_RightImage;
	this->Invalidate();
}

void CImageProcessingDlg::OnBnClickedNavigator5()
{
	// TODO: Add your control notification handler code here
	m_DestMesh = m_DownMesh;
	m_ViewImage = m_DownImage;
	this->Invalidate();
}

// ǽð ̴ ...
void CImageProcessingDlg::OnBnClickedViewer()
{
	// TODO: Add your control notification handler code here
	if(!m_pAniViewer && m_isCreateAni)
	{
		m_pAniViewer = new AniViewer();
		m_pAniViewer->m_pMainDlg = this;				// ̰ɷ ޻ڿ  Ҽ ְ 
		m_pAniViewer->m_AnimationMesh = this->m_AnimationMesh;
		m_pAniViewer->DoModal();
		m_pAniViewer->DestroyWindow();
		delete m_pAniViewer;
		m_pAniViewer = NULL;
	}
	else
		AfxMessageBox("First, push \"Create Ani\"button" );
}

//  ̹  
void CImageProcessingDlg::compute_ImageApply(int x, int y)
{
	MESHPOINT *nowMesh;
	CImage *nowImage;
	
	// ϴ 簪 
	nowImage = m_ViewImage;
	nowMesh = m_DestMesh;

	CImage  *tempImage;
	tempImage = new CImage();
	tempImage->Create(m_SrcImage.GetWidth(), m_SrcImage.GetHeight(), m_SrcImage.GetBPP());

	m_DestMesh = m_AnimationMesh[x][y];
	this->Invalidate();

	CString msg;
	msg.Format("m_AnimationMesh[%d][%d] : 0x%x", x, y, &m_AnimationMesh);
	this->SetDlgItemText(IDC_COMMANDBOX, msg);
	m_ViewImage = tempImage;

	//    ƾ..  ϳ..
	CString strFileName;
	strFileName.Format("image[%d][%d].png", x, y);
	OnBnClickedApply();
	m_ViewImage->Save(strFileName);
	
	// پ 
	m_ViewImage = nowImage;
	m_DestMesh = nowMesh;

	delete tempImage;
}

// ڳ  ϱ
void CImageProcessingDlg::compute_CornerImage
(int x, int y, MESHPOINT *x_mesh, MESHPOINT *y_mesh)
{
	for(int i=0; i < MeshSizeX * MeshSizeY; ++i)
	{
		m_AnimationMesh[x][y][i].x = x_mesh[i].x;
		m_AnimationMesh[x][y][i].y = y_mesh[i].y;
	}
	compute_ImageApply(x, y);
}

//  ϱ
void CImageProcessingDlg::compute_CrossingImage
(int x, int y, MESHPOINT *mesh1, MESHPOINT *mesh2, int step, float add)
{
	// ܰ ġ, ׸ | a | a' | a'' | b | ̸ a(mesh1) b(mesh2) ĭ 
	for(int i=0; i < MeshSizeX * MeshSizeY; ++i)
	{
		float add_x;
		(mesh1[i].x == mesh2[i].x) ? add_x = 0 : add_x = (float)((mesh2[i].x - mesh1[i].x) / step);
		float add_y;
		(mesh1[i].y == mesh2[i].y) ? add_y = 0 : add_y = (float)((mesh2[i].y - mesh1[i].y) / step);
		m_AnimationMesh[x][y][i].x = mesh1[i].x + (int)(add_x * add);
		m_AnimationMesh[x][y][i].y = mesh1[i].y + (int)(add_y * add);
	}

	compute_ImageApply(x, y);
}

void CImageProcessingDlg::OnBnClickedCreateani()
{
	// ִ ޽ ؼ ٴܰ ׸ Ѵ.
	//  5ܰ ۾ ϸ, ó  ׸ , 
	//   ̵ ׸ 
	// ׸ Ҷ  ׸  ٸ.. 
	// ǥ  ٸǷ for   ϴ ϰ ߺ 
	m_isCreateAni = true;

	// 1. ϴ  ׸ 
	compute_ImageApply(m_AnimationStep>>1	,		0);
	compute_ImageApply(0					,		m_AnimationStep>>1);
	compute_ImageApply(m_AnimationStep>>1	,		m_AnimationStep>>1);
	compute_ImageApply(m_AnimationStep-1	,		m_AnimationStep>>1);
	compute_ImageApply(m_AnimationStep>>1	,		m_AnimationStep-1);

	// 2. ** 4  ϱ **
	compute_CornerImage(0					,			      0, m_LeftMesh,  m_UpMesh);
	compute_CornerImage(m_AnimationStep-1	,				  0, m_RightMesh, m_UpMesh);
	compute_CornerImage(0					, m_AnimationStep-1, m_LeftMesh,  m_DownMesh);
	compute_CornerImage(m_AnimationStep-1	, m_AnimationStep-1, m_RightMesh, m_DownMesh);

	// 3. **  ,ϴܺκ **
	for(int y = 1; y < (m_AnimationStep>>1); ++y)
		compute_CrossingImage(0, y,
							m_AnimationMesh[0][0], m_LeftMesh,
							m_AnimationStep>>1, (float)y);
	for(int y = (m_AnimationStep>>1)+1; y < m_AnimationStep-1; ++y)
		compute_CrossingImage(0, y,
							m_LeftMesh, m_AnimationMesh[0][m_AnimationStep-1],
							m_AnimationStep>>1, (float)(y - (m_AnimationStep>>1)));	

	// 4. ** ߾ ,ϴܺκ **
	for(int y = 1; y < (m_AnimationStep>>1); ++y)
		compute_CrossingImage(m_AnimationStep>>1, y,
							m_AnimationMesh[m_AnimationStep>>1][0], m_CenterMesh,
							m_AnimationStep>>1, (float)y);
	for(int y = (m_AnimationStep>>1)+1; y < m_AnimationStep-1; ++y)
		compute_CrossingImage(m_AnimationStep>>1, y, m_CenterMesh,
							m_AnimationMesh[m_AnimationStep>>1][m_AnimationStep-1],
							m_AnimationStep>>1, (float)(y - (m_AnimationStep>>1)));

	// 5. **  ,ϴܺκ **
	for(int y = 1; y < (m_AnimationStep>>1); ++y)
		compute_CrossingImage(m_AnimationStep-1, y,
							m_AnimationMesh[m_AnimationStep-1][0], m_RightMesh,
							m_AnimationStep>>1, (float)y);
	for(int y = (m_AnimationStep>>1)+1; y < m_AnimationStep-1; ++y)
		compute_CrossingImage(m_AnimationStep-1, y,
							m_RightMesh, m_AnimationMesh[m_AnimationStep-1][m_AnimationStep-1],
							m_AnimationStep>>1, (float)(y - (m_AnimationStep>>1)));	

	
	// 6. ---  ߾  κ ϱ
	for(int y = 0; y < m_AnimationStep; ++y)
	{
		for(int x = 1; x < (m_AnimationStep>>1); ++x)
		{
			compute_CrossingImage(x, y,
							m_AnimationMesh[0][y], m_AnimationMesh[m_AnimationStep>>1][y], 
							m_AnimationStep>>1, (float)x);
		}
	}

	// 7. --- ߾Ӱ   κ ϱ
	for(int y = 0; y < m_AnimationStep; ++y)
	{
		for(int x = (m_AnimationStep>>1) + 1; x < m_AnimationStep; ++x)
		{
			compute_CrossingImage(x, y, 
							m_AnimationMesh[m_AnimationStep>>1][y], m_AnimationMesh[m_AnimationStep-1][y],
							m_AnimationStep>>1, (float)(x - ((m_AnimationStep >>1))));
		}
	}
	
}
