// ImageProcessingDlg.h : header file
//
#pragma once

#include "AniViewer.h"
#include <comdef.h>

// ӵ üũϱ + - * / Ǵ° ī͸   
const int MeshNumber = 10;
const int MeshSizeX = MeshNumber;
const int MeshSizeY = MeshNumber;
const int AnimationFrame = 5;

// CImageProcessingDlg dialog
class CImageProcessingDlg : public CDialog
{
// Construction
public:
	CImageProcessingDlg(CWnd* pParent = NULL);	// standard constructor
	~CImageProcessingDlg()
	{
		delete m_pMeshWarp;
		delete [] m_SrcMesh;
		
		delete m_LeftImage;
		delete m_RightImage;
		delete m_UpImage;
		delete m_DownImage;
		delete m_CenterImage;

		// 3 ޸ 
		for(int i=0; i< m_AnimationStep; ++i)
			for(int j=0; j< m_AnimationStep; ++j)
				delete [] m_AnimationMesh[i][j];

		for(int i=0; i<m_AnimationStep; ++i)
			delete [] m_AnimationMesh[i];

		delete []m_AnimationMesh;

	//	if(m_pAniViewer != NULL)
	//		delete m_pAniViewer;
	}
// Dialog Data
	enum { IDD = IDD_IMAGEPROCESSING_DIALOG };
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

public:
	CString sFilename;							// ̹  ̸
	CImage m_SrcImage;							//  ̹
    CImage *m_ViewImage;						//  ̹ 

	CImage *m_LeftImage;
	CImage *m_RightImage;
	CImage *m_UpImage;
	CImage *m_DownImage;
	CImage *m_CenterImage;

	MESHPOINT *m_SrcMesh;						// ޽ ġ
	MESHPOINT *m_DestMesh;						// ޽ ġ
	
	MESHPOINT *m_LeftMesh;						// ޽ , ...  .
	MESHPOINT *m_RightMesh;
	MESHPOINT *m_UpMesh;
	MESHPOINT *m_DownMesh;
	MESHPOINT *m_CenterMesh;
	
	MESHPOINT ***m_AnimationMesh;
	MESHPOINT m_PickPoint;						//    ǥ.
	bool m_isMouseMove;							// 콺 ̰ ִ°?
	bool m_isCreateAni;							// ϸ̼ °?
	float m_EdgeWidth;							//  α
	float m_EdgeHeight;							//  α
	int m_ImageWidth;							// ̹ μ 
	int m_ImageHeight;
	int m_power;								//  
	int m_AnimationStep;						// ϸ̼ 

	MESHPOINT m_NowMousePos;					//  콺 ġ
	MESHPOINT m_TrackingPos;					// Ʈŷ ġ

	int	m_nFilterLoad;							// ׸ Ҷ ʿ亯..
	bool m_isMeshInit;							// ޽ ʱȭ ۾ΰ?
	CMeshWarp *m_pMeshWarp;
	AniViewer *m_pAniViewer;
	CString m_ImageName;

	void GetFaceCoordnates();
	void compute_ImageApply(int x, int y);
	void compute_CornerImage
		(int x, int y, MESHPOINT *x_mesh, MESHPOINT *y_mesh);
	void compute_CrossingImage
		(int x, int y, MESHPOINT *mesh1, MESHPOINT *mesh2, int step, float add);
	void ApplyMeshSave();
// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedImageload();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);

	afx_msg void OnBnClickedMeshset();
	afx_msg void OnBnClickedApply();
	afx_msg void OnBnClickedMeshformat();

	afx_msg void OnBnClickedSrcmesh1();
	afx_msg void OnBnClickedSrcmesh2();
	afx_msg void OnBnClickedDestmesh1();
	afx_msg void OnBnClickedDestmesh2();
	afx_msg void OnBnClickedMeshsave();
	afx_msg void OnBnClickedMeshload();
	afx_msg void OnBnClickedImagesave();
	afx_msg void OnBnClickedPower1();
	afx_msg void OnBnClickedPower2();
	afx_msg void OnBnClickedPower3();
	afx_msg void OnBnClickedPower4();
	afx_msg void OnBnClickedViewer();
	afx_msg void OnBnClickedNavigator2();
	afx_msg void OnBnClickedNavigator3();
	afx_msg void OnBnClickedNavigator4();
	afx_msg void OnBnClickedNavigator5();
	afx_msg void OnBnClickedNavigator1();
	afx_msg void OnBnClickedCreateani();
};
